module GlitchHelperGlitchModule

using ..Ahorn, Maple

@pardef GlitchEntity(x1::Integer, y1::Integer, hasLines::Bool=false) = Entity("GlitchHelper/Glitch", x=x1, y=y1, hasLines=hasLines, nodes=Tuple{Int, Int}[])

function _finalizer(entity)
  x, y = Ahorn.position(entity)
  entity.data["nodes"] = [(x + 24, y)]
end

const placements = Ahorn.PlacementDict(
	"Glitch (Glitch Helper)" => Ahorn.EntityPlacement(
		GlitchEntity,
		"rectangle",
		Dict{String, Any}(),
		_finalizer
	)
)

sprite = "objects/glitch/glitchgreen00"

Ahorn.nodeLimits(entity::GlitchEntity) = 1, 1

function Ahorn.selection(entity::GlitchEntity)
  x, y = Ahorn.position(entity)
  nodes = get(entity.data, "nodes", ())
  res = [Ahorn.Rectangle(x - 8, y - 8, 16, 16)]
  for node in nodes
    nodeX, nodeY = Int.(node)
    push!(res, Ahorn.Rectangle(nodeX - 8, nodeY - 8, 16, 16))
  end
  return res
end

function Ahorn.renderSelectedAbs(ctx::Ahorn.Cairo.CairoContext, entity::GlitchEntity, room::Maple.Room)
  startX, startY = Int(entity.data["x"]), Int(entity.data["y"])
  nodes = get(entity.data, "nodes", ())
  if length(nodes) > 0
    stopX, stopY = Int.(nodes[1])
    Ahorn.drawArrow(ctx, startX, startY, stopX, stopY, Ahorn.colors.selection_selected_fc, headLength=4)
  end
end

function Ahorn.renderAbs(ctx::Ahorn.CairoContext, entity::GlitchEntity, room::Maple.Room)
  x, y = Ahorn.position(entity)
  nx, ny = Int.(get(entity.data, "nodes", ())[1])

  sprite = "objects/glitch/glitchgreen00"

  sprite2 = "objects/glitch/glitchexit"

  Ahorn.drawSprite(ctx, sprite, x, y)

  Ahorn.drawSprite(ctx, sprite2, nx, ny)
end

end