module GlitchHelperMine

using ..Ahorn, Maple

@mapdef Entity "GlitchHelper/Mine" Mine(x::Integer, y::Integer, isMine::Bool=true)

const placements = Ahorn.PlacementDict(
    "Mine (Glitch Helper)" => Ahorn.EntityPlacement(
        Mine,
        "point",
        Dict{String, Any}(
            "isMine" => true
        )
    ),
    "Tile (Glitch Helper)" => Ahorn.EntityPlacement(
        Mine,
        "point",
        Dict{String, Any}(
            "isMine" => false
        )
    )    
)

function Ahorn.selection(entity::Mine)
    x, y = Ahorn.position(entity)

    return Ahorn.Rectangle(x+8, y+8, 16, 16)
end

function mineSprite(entity::Mine)
	mine = get(entity.data, "isMine", false)

	if mine
		return "objects/mine/mine"
	else
		return "objects/mine/tile"
	end
end

function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::Mine, room::Maple.Room)
    sprite = mineSprite(entity)

    Ahorn.drawSprite(ctx, sprite, 16, 16)
end

end

