local drawableRectangle = require "structs.drawable_rectangle"

local blueGlitch = {}

blueGlitch.name = "GlitchHelper/BlueGlitch"

blueGlitch.nodeLimits = {1, 1}
blueGlitch.nodeLineRenderType = "line"
blueGlitch.nodeVisibility = "always"

blueGlitch.fieldInformation = {
    destroyRange = {
        fieldType = "integer",
        minimumValue = 0.0
    }
}

blueGlitch.placements = {
    {
        name = "blue_glitch",
        data = {
            hasLines = false,
            destroyRange = 16,
            hideDestroyRange = false,
            hideLines = false
        }
    }
}

local rangeColorIn = {85 / 255, 80 / 255, 229 / 255, 144 / 255}
local rangeColorOut = {85 / 255, 80 / 255, 229 / 255, 200 / 255}

blueGlitch.texture = "objects/glitch/glitchblue00"

function blueGlitch.nodeSprite(room, entity, node, nodeIndex, viewport)
    local x, y = node.x or 0, node.y or 0
    local destroyRange = (entity.destroyRange or 16) + 7

    return drawableRectangle.fromRectangle("bordered", x - destroyRange, y - destroyRange, destroyRange * 2, destroyRange * 2, rangeColorIn, rangeColorOut)
end

return blueGlitch
