local drawableRectangle = require "structs.drawable_rectangle"

local purpleGlitch = {}

purpleGlitch.name = "GlitchHelper/PurpleGlitch"

purpleGlitch.nodeLimits = {1, 1}
purpleGlitch.nodeLineRenderType = "line"
purpleGlitch.nodeVisibility = "always"

purpleGlitch.fieldInformation = {
    destroyRange = {
        fieldType = "integer",
        minimumValue = 0.0
    }
}

purpleGlitch.placements = {
    {
        name = "purple_glitch",
        data = {
            hasLines = false,
            destroyRange = 16,
            hideDestroyRange = false,
            hideLines = false
        }
    }
}

local rangeColorIn = {148 / 255, 78 / 255, 228 / 255, 144 / 255}
local rangeColorOut = {148 / 255, 78 / 255, 228 / 255, 200 / 255}

purpleGlitch.texture = "objects/glitch/glitchpurple00"

function purpleGlitch.nodeSprite(room, entity, node, nodeIndex, viewport)
    local x, y = node.x or 0, node.y or 0
    local destroyRange = (entity.destroyRange or 16) + 7

    return drawableRectangle.fromRectangle("bordered", x - destroyRange, y - destroyRange, destroyRange * 2, destroyRange * 2, rangeColorIn, rangeColorOut)
end

return purpleGlitch
